/*******************************************************************************
* File Name: Cnt_ISR.h
* Version 1.50
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/
#if !defined(__Cnt_ISR_INTC_H__)
#define __Cnt_ISR_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>

#if(CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC3)     
    #if(CYDEV_CHIP_REVISION_USED <= CYDEV_CHIP_REVISION_3A_ES2)      
        #include <intrins.h>
        #define Cnt_ISR_ISR_PATCH() _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
    #endif
#endif


/* Interrupt Controller API. */
void Cnt_ISR_Start(void);
void Cnt_ISR_StartEx(cyisraddress address);
void Cnt_ISR_Stop(void) ;

CY_ISR_PROTO(Cnt_ISR_Interrupt);

void Cnt_ISR_SetVector(cyisraddress address) ;
cyisraddress Cnt_ISR_GetVector(void) ;

void Cnt_ISR_SetPriority(uint8 priority) ;
uint8 Cnt_ISR_GetPriority(void) ;

void Cnt_ISR_Enable(void) ;
uint8 Cnt_ISR_GetState(void) ;
void Cnt_ISR_Disable(void) ;

void Cnt_ISR_SetPending(void) ;
void Cnt_ISR_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the Cnt_ISR ISR. */
#define Cnt_ISR_INTC_VECTOR            ((reg16 *) Cnt_ISR__INTC_VECT)

/* Address of the Cnt_ISR ISR priority. */
#define Cnt_ISR_INTC_PRIOR             ((reg8 *) Cnt_ISR__INTC_PRIOR_REG)

/* Priority of the Cnt_ISR interrupt. */
#define Cnt_ISR_INTC_PRIOR_NUMBER      Cnt_ISR__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable Cnt_ISR interrupt. */
#define Cnt_ISR_INTC_SET_EN            ((reg8 *) Cnt_ISR__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the Cnt_ISR interrupt. */
#define Cnt_ISR_INTC_CLR_EN            ((reg8 *) Cnt_ISR__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the Cnt_ISR interrupt state to pending. */
#define Cnt_ISR_INTC_SET_PD            ((reg8 *) Cnt_ISR__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the Cnt_ISR interrupt. */
#define Cnt_ISR_INTC_CLR_PD            ((reg8 *) Cnt_ISR__INTC_CLR_PD_REG)



/* __Cnt_ISR_INTC_H__ */
#endif
